#ifndef SEMSGCONSUMERDPM_HH
#define SEMSGCONSUMERDPM_HH

/* SEMsgConsumer_dpm
 * A plugin that feeds dpm with
 * app-level notifications.
 *
 *
 * by Fabrizio Furano, CERN, Oct 2010
 */

#include "../SEMsgConsumer.hh"



// Subclass that overrides the events with dpm-specific calls
class SEMsgConsumer_dpm: public SEMsgConsumer {
public:

   SEMsgConsumer_dpm( const std::string& brokerURI,
                      const std::string& destname,
                      bool useTopic = false,
                      bool sessionTransacted = false );
   
   virtual void onMessageChmod( const cms::MapMessage* m );
   virtual void onMessageFileNotAvailable( const cms::MapMessage* m );
   virtual void onMessageAddReplica( const cms::MapMessage* m );
   virtual void onMessageSetACL( const cms::MapMessage* m );
};


#endif
