#ifndef SEMSGPRODUCERDPM_HH
#define SEMSGPRODUCERDPM_HH

/* SEMsgProducer_dpm
 * A plugin that applies dpm-specifics to message sending
 *
 *
 *
 * by Fabrizio Furano, CERN, Feb 2010
 */



#include "../SEMsgProducer.hh"




class SEMsgProducer_dpm : public SEMsgProducer {


public:
   SEMsgProducer_dpm( SimpleDebug *logobj,
		      Config *cfgobj,
		      const std::string& brokerURI,
		      const std::string& destname,
		      bool useTopic = false,
		      bool sessionTransacted = false ):
     SEMsgProducer(logobj, cfgobj, brokerURI, destname, useTopic, sessionTransacted) {};

   // Some examples of useful messages to override with dpm-related processing
   virtual int NotifyNotAvailable(char *authDN, char *filename);
   virtual int NotifyAvailable(char *authDN, char *filename);
   virtual int NotifyChmod(char *authDN, char *filename, int perm);
   virtual int NotifyChown(char *authDN, char *filename, char *username, char *groupname);
   virtual int NotifyDeleted(char *authDN, char *filename);
   virtual int NotifySetACL(char *authDN, char *filename, char * acl);
   virtual int NotifyAddReplica(char *authDN, 
				char      *lfn,
				char      *guid,
				int        mode,
				long long  size,
				char      *csumtype,
				char      *csumvalue,
				char      *server,
				char      *sfn,
				char      *status,
				char      *f_type,
				char      *poolname,
				char      *fs);

  virtual int CanNotifyNotAvailable() { return CFG->GetBool("prodapi.dpmplugin.notifynotavailable", true); };
  virtual int CanNotifyAvailable()    { return CFG->GetBool("prodapi.dpmplugin.notifyavailable", true); };
  virtual int CanNotifyChmod()        { return false; };
  virtual int CanNotifyChown()        { return false; };
  virtual int CanNotifyDeleted()      { return CFG->GetBool("prodapi.dpmplugin.notifydeleted", true); };
  virtual int CanNotifySetACL()       { return false; };
  virtual int CanNotifyAddReplica()   { return CFG->GetBool("prodapi.dpmplugin.notifyaddreplica", false); };
};





#endif
