#ifndef SEMSGCONSUMERLFC_HH
#define SEMSGCONSUMERLFC_HH

/* SEMsgConsumer_lfc
 * A plugin that feeds lfc with
 * app-level notifications.
 *
 *
 * by Fabrizio Furano, CERN, Nov 2010
 */

#include "../SEMsgConsumer.hh"



// Subclass that overrides the events with lfc-specific calls
class SEMsgConsumer_lfc: public SEMsgConsumer {
public:

   SEMsgConsumer_lfc( const std::string& brokerURI,
                      const std::string& destname,
                      bool useTopic = false,
                      bool sessionTransacted = false );
 
   // These do what they say
   virtual void onMessageFileNotAvailable( const cms::MapMessage* m );
   virtual void onMessageFileAvailable( const cms::MapMessage* m );
   virtual void onMessageFileDeleted( const cms::MapMessage* m );
   virtual void onMessageAddReplica( const cms::MapMessage* m );

};


#endif
